#include <stdio.h>
#include <string.h>
#include "microXML.h"

 short Wrd_next(char *str,short i,short j)
{ //Gets next word in string str, divided by delimiters, from i to j characters; returns delimiter index 
 static char Wrd_delimiters[32]=",;:=*/";
 short k;
 char c,*d;
 k=i; while(k < j)
   { 
    c=str[k]; 
    d=Wrd_delimiters; while(*d){ if(c==*d)return k; d++; }
    if(c==0)break;
    k++;
    }
 return k;
 }

 short Numbers_getDigit(char ch,short r)
{ // converts char (0-9,A-F) to digit (0-15)
 short k;

 k=-1;
 if('0' <= ch && ch <= '9')k = ch-'0'; 
 if(r >= 10)
   {
    if('a' <= ch && ch <= 'f')k = ch-'a'+10; else
    if('A' <= ch && ch <= 'F')k = ch-'A'+10;
    }
 if(k >= r)k=-1;
 return k;
 }

 unsigned int Numbers_atou(char *s,short m,short n)
{ // converts substring s[m <= i < n] to unsigned int 
 unsigned int a;
 short i,r,k;
 char c;

 a=0; i=m; r=10; while(s[i]==' ')i++; if(s[i]=='+')i++;
 while(i < n)
   {
    if((k=Numbers_getDigit((c=s[i]),r)) >= 0)a=a*r+k;
    else { if(c == 'x' || c== 'X')r=16; else break; }
    i++;
    }
 return a;
 }

 int Numbers_atol(char *s,short m,short n)
{ // converts substring s[m <= i < n] to int 
 int a; short sn,i;

 sn=1; a=0; i=m; while(s[i]==' ')i++;
 if(s[i]=='-'){ sn=-1; i++; }
 a = Numbers_atou(s,i,n);
 if(sn < 0)a=-a;
 return a;
 }

 double Numbers_atod(char *s,short m,short n)
{ // converts substring s[m <= i < n] to double
 short i,j,sn;
 char c;
 int l;
 double d,e;

 l=0; i=m; while(s[i]==' ')i++;
 sn=1; if(s[i]=='-'){sn=-1; i++;}
 j=i; while(j <= n)
   {
    c=s[j];
    if(('0' <= c && c <= '9') || c=='-' || c=='+')j++; 
    else { l=Numbers_atou(s,i,j); break; } 
    }
 d=l; l=0;
 if(s[j]=='.')
   {
    j++; e=1;
    i=j; while(j < n)
      { c=s[j]; if('0' <= c && c <= '9'){ e*=10; j++; } else break; }
    l=Numbers_atou(s,i,j); 
    if(l != 0)d+=l/e;
    }
 if(sn < 0)d=-d;
 return d;
 }


 int XML_processTag(XMLmin xml)
{ // Procedure template for xml parsing
 return 0;
 };

 void  XML_push(XMLmin xml,void *p) // push pointer to xml stack
{ xml->stack[(xml->sp)++] = p; }

 void *XML_pop(XMLmin xml)  // pop pointer from xml stack
{ return xml->stack[--(xml->sp)]; }

 XMLmin new_XMLmin(int len,int st)
{ // create new XML process structure; len - length of maximum tag, st - size of stack
 XMLmin xml;
 Stream f;
 char *txt;
 int l,c;

 xml = (XMLmin)malloc(sizeof(struct _XMLmin_));

 xml->l = len;
 xml->txt = txt = malloc(len);
 xml->processTag = XML_processTag;
 xml->stack = (void *)malloc(sizeof(void *)*st);
 xml->sp=0;
 xml->object=0;
// xml->index=0;
// xml->mem=0;
 xml->level=0;
 xml->f = null;
 return xml;
 }

 XMLmin nul_XMLmin(XMLmin xml)
{ // free memory of XML structure
 free(xml->stack);
 free(xml->txt);
 if(xml->f != null)Stream_close(xml->f);
 free(xml);
 return 0; 
 }

 int XML_attribute(XMLmin xml,char *str)
{ // get attribute str to xml->txt (internal function, not for user)  
 int i,j,k,l;
 char c,ch;
 char *txt;

 txt = xml->txt;

 i=0;

 j=0; while((c = txt[j]) != ' '){ if(c==0)return 0; j++; }

 while((c = txt[j]) != 0)
   {
    if(c==str[i])
      {
       i++;
       if(str[i]==0)
         {
          ch=txt[j+1];
          if(ch == ' ' || ch == '=')
            {
             while((c = txt[j]) != 0)
               {  
                if(c == '=')
                  {
                   while((c = txt[j]) != 0)
                     {
                      if(c == 39 || c == 34)
                        {
                         ch = c;
                         j++; k=0; while((c = txt[j+k]) != 0)
                           {
                            if(c == ch)return (j<<16) | k;
                            k++;
                            }
                         return 0;
                         }
                      j++;
                      }
                   return 0;
                   }
                j++;
                }
             return 0;
             }
          i=0;
          }
       }
    else 
      {
       i=0; while((c = txt[j]) != ' '){ if(c==0)return 0; j++; }
       } 
    j++;
    }
 return 0;
 }

 int XML_getTag(XMLmin xml)
{ // get next xml tag (internal function, not for user)  
 int c;
 int j,max,i;
 Stream f;
 char *txt;
 char ch;
 int quote;

 f   = xml->f;
 txt = xml->txt;
 max = xml->l;

 quote=0;

 j=0; while(1)
   { 
    c = Stream_get(xml->f);
    if(quote != 0){ if(c==quote){ quote=0; txt[j++]=c; continue; } }

    if(c < 0){ txt[j]=0; j=-1; break; }
    if(c == '>' && quote==0){ txt[j]=0; break; }
    if(c == 39 || c == 34){ quote=c; txt[j++]=c; continue; }
    if(c == '\r')c='\n'; if(c == '\n' && j > 0 && txt[j-1]=='\n')continue;

    if(j==2 && txt[0]=='!' && txt[1]=='-' && c=='-')
      {
       j=0; while((c = Stream_get(xml->f)) >= 0)
         {
          if(c == '-')j++;
          else { if(c == '>' && j==2)return 0; j=0; }
          }
       return -1;
       } 
    txt[j++]=c; 
    if(j >= max){ printf("\n XML error: text overflow"); exit(0); }
    }        

 xml->tag=0;
 if(j > 0)
   {
    if(txt[0] != '!')
      {
       if(txt[0]=='/'){ xml->tag = XML_CLOSE; txt++; j--; }
       else
         {
          xml->tag = XML_OPEN;
          if(txt[j-1] == '/')xml->tag |= XML_CLOSE;
          }
       i=0; while(i < j)
         {
          ch = txt[i]; 
          if(ch==' ' || ch=='\r' || ch=='\n' || ch=='\t' || ch=='/')
            { break;}
          xml->tagname[i]=ch;
          i++;
          }
       xml->tagname[i]=0;
       xml->processTag(xml);
       }
    }
 return j;
 }

 int XML_getString(XMLmin xml,char *att,char *str)
{ // get attribute att as string str; if attribute exists return string length, oterwise returns 0
 int i,j,k,l,val;
 char *txt;

 txt = xml->txt;
 l = 0;
 k = XML_attribute(xml,att);
 if(k !=0 )
   {
    j=k>>16; l=k&0xffff;
    i=0; while(i < l){ str[i++] = txt[j++]; } str[i]=0;
    }
 return l;
 }

 int XML_getInt(XMLmin xml,char *att,int def)
{  // get attribute att as integer; if attribute does not exist returns def
 int k,j,l,val;

 val = def;
 k = XML_attribute(xml,att);
 if(k !=0 )
   {
    j=k>>16; l=k&0xffff;
    val = Numbers_atol(xml->txt,j,j+l);
    }
 return val;
 }

 int XML_getArrayLength(XMLmin xml,char *att)
{ // if attribute att is array of numbers, returns length of array
 int i,j,k,l,n;
 char *txt;

 txt = xml->txt;

 k = XML_attribute(xml,att);

 n=0;
 if(k !=0 )
   {
    i=k>>16; l=(k&0xffff)+i; 
    while(i < l){ j = Wrd_next(txt,i,l); i=j+1; n++; }
    }
 return n;
 }

 int XML_getIntArray(XMLmin xml,char *att,int *a,int len)
{ // if attribute att is array of integer, returns int array a, len - length of a
 int i,j,k,l,n;
 char *txt;

 txt = xml->txt;

 k = XML_attribute(xml,att);
 n=0;
 if(k !=0 )
   {
    i=k>>16; l=(k&0xffff)+i; 
    while(i < l && n < len)
      { j = Wrd_next(txt,i,l); a[n++]=Numbers_atol(txt,i,j); i=j+1; }
    }
 return n;
 }

 int XML_getFloatArray(XMLmin xml,char *att,float *a,int len)
{ // if attribute att is array of float, returns int array a, len - length of a
 int i,j,k,l,n;
 char *txt;

 txt = xml->txt;

 k = XML_attribute(xml,att);
 n=0;
 if(k !=0 )
   {
    i=k>>16; l=(k&0xffff)+i; 
    while(i < l && n < len)
      { j = Wrd_next(txt,i,l); a[n++]=(float)Numbers_atod(txt,i,j); i=j+1; }
    }
 return n;
 }

 double XML_getReal(char *str,int n)
{ // return double from string str of length n (internal, not for user) 
 int i,l,e,s,m;
 unsigned char c;
 double d,p,f;

 l=0; p=0; f=1; s=1; e=0; m=0;

 i=0; 

 if(str[i]=='-'){ s=-1; i++; }  
 while(i < n)
   {
    c = str[i];
    if('0' <= c && c <= '9')l = l*10 + (c-'0'); 
    i++;
    if(c=='e' || c=='E' || c=='.')break;
    }
 if(c == '.')
   {
    while(i < n)
      {
       c = str[i];
       if('0' <= c && c <= '9'){ p = p*10 + (c-'0'); f*=10; }
       i++;
       if(c=='e' || c=='E')break;
       }
    }
 if(c=='e' || c=='E')
   {
    if(str[i]=='-'){ m=1; i++; }  
    while(i < n)
      {
       c = str[i];
       if('0' <= c && c <= '9'){ e = e*10 + (c-'0'); }
       i++;
       }
    }

 d = s*(l + (double)p/f);
 if(e > 0)
   { 
    if(m){ i=0; while(i++ < e)d/=10; }
    else { i=0; while(i++ < e)d*=10; }
    }

 return d;
 }

 double XML_getDouble(XMLmin xml,char *att,double def)
{  // get attribute att as double; if attribute does not exist returns def
 int k,j,l;
 double val;

 val = def;
 k = XML_attribute(xml,att);
 if(k !=0 )
   {
    j=k>>16; l=k&0xffff;
    val = XML_getReal(xml->txt+j,l);
    }
 return val;
 }

 float XML_getFloat(XMLmin xml,char *att,float def)
{ // get attribute att as float; if attribute does not exist returns def
 return  (float)XML_getDouble(xml,att,def);
 }

 int XML_isTag(XMLmin xml,char *str)
{ // return flags of current xml tag if current tag equals str
 int i;
 char c;
 char *txt;

 txt = xml->tagname;
 i=0; while((c=str[i])!=0){ if(c != '?' && c != txt[i])return 0; i++; }
 if(txt[i]!=0)return 0;
 return xml->tag;
 }

 int XML_getText(XMLmin xml)
{ // gets current xml text (internal function, not for user)
 int c;
 int j,max;
 short blank;
 Stream f;
 char *txt;

 f = xml->f;
 txt = xml->txt;
 max = xml->l;

 blank=1;
 j=0; while(j < max)
   {
    c = Stream_get(xml->f);
    if(c < 0 || c=='>'){ txt[j]=0; return -1; }
    if(c == '<') break;
    if(c == '\r')c='\n'; if(c == '\n' && j > 0 && txt[j-1]=='\n')continue;
    if(c != '\n' && c != ' ' && c != '\t')blank=0;
    txt[j++]=c; 
    }
 if(blank)j=0;
 txt[j]=0;

 if(j > 0)
   {
    xml->tag = XML_TEXT;
    xml->processTag(xml);
    }
 return j;
 }

 void XML_stream(XMLmin xml,Stream stream)
{ // Parses xml file (stream) with callback procedure
 int c;
 if(stream != null)
   {
    while((c=Stream_get(stream))!='<')
      { if(c < 0)Stream_close(stream); return; }

    XML_push(xml,xml->f);
    xml->f = stream;
    while(XML_get(xml));
    xml->f = XML_pop(xml);
    }
 }

 int XML_get(XMLmin xml)
{ // check if there are tags or texts in xml (internal function, not for user)
 if(XML_getTag(xml) < 0)return  0;
 if(XML_getText(xml) < 0)return 0; 
 return 1;
 }

/***** User code ************************************************/

// User data to be input

 char name[256]="";
 float age=0;
 char country[32]="";

 int processXML(XMLmin xml)
{ // Callback procedure to analse xml
  // It is called with every tag 
  // <XXX> is called with XML_OPEN flag
  // </XXX> is called with XML_CLOSE flag
  // <XXX /> is called with both XML_OPEN and XML_CLOSE flags
  // Text between tags is called with XML_TEXT flag
  // Example of parsing micro.xml file
 int tag;
 char s[256];

 if((tag = XML_isTag(xml,"user"))!=0)
   { // tag "user"
    if(tag & XML_OPEN)
      { // open "user" tag; tag may have "name" attribute
       if((XML_getString(xml,"name",s)) > 0) // if "user" has "name" copy it to name array
        { strcpy(name,s); }
       }
    if(tag & XML_CLOSE)
      {
       printf("name=%s  age=%.0f  country=%s\n",name,age,country);
       } // print data when close "user"
    } else
 if((tag = XML_isTag(xml,"param"))!=0)
   { // tag "param"
    if(tag & XML_OPEN)
      { // open "param" tag; tag may have "name" attribute
       if((XML_getString(xml,"name",s)) > 0)
         { // param has "name" attribute
          if(strcmp(s,"Age")==0) // name attribute equals "Age"
            { age=XML_getFloat(xml,"value",0); } // get attribute value in age variable as float
          if(strcmp(s,"Country")==0)// name attribute equals "Country"
            { if(XML_getString(xml,"value",s) > 0) strcpy(country,s); }  // get attribute value in country array
          }
       }
    if(tag & XML_CLOSE) { } //nothing to do when closing "param"
    }
 return 0;
 }

 int main(int na,char *args[])
{
 XMLmin xml;
 Stream stream;
 char fname[256]="micro.xml"; if(na > 1)strcpy(fname,args[1]);

 if((stream = Stream_open(fname,"r")) != 0)
   {
    xml = new_XMLmin(8192,1024);
    xml->processTag = processXML;
    XML_stream(xml,stream);
    xml = nul_XMLmin(xml);
    Stream_close(stream);
    }
 return 0;
 }
